# Mosfet Minecraft Bot

## How to Grab Supplies

![a single barrel with two double chests above it](media/grab_supplies.png)

Mosfet will automatically grab supplies he needs to do his job from nearby
[barrels](https://minecraft.fandom.com/wiki/Barrel#Crafting). Before starting
the job, he will check each barrel for related supplies and grab some depending
on the job. He will recheck the barrels for supplies periodically to try and get
more.

If he can't find any barrels, he will try to continue doing the job anyway. If
his inventory is too full, he will skip grabbing supplies.

### Advanced Details

The global `g.maximum_supply_slots` in `bot.py` controls the maximum amount of
used slots allowed while grabbing supplies.

In `jobs.py`, each job sets the `grab_supplies_states.supplies` dictionary to
specify what items to grab and how many. Here's an example:

```
self.grab_supplies_states.supplies = {
	tuple([items.PUMPKIN_ID]): (64, 3),
}
```

This tells Mosfet to grab three stacks of pumpkins if he ever has less than 64.
